#include <bits/stdc++.h>
#define FOR(i, a, b) for (int i = (a); i <= (b); i++)
#define FOD(i, a, b) for (int i = (a); i >= (b); i--)
#define REP(i, n) for (int i = 0; i < (n); i++)
#define ALL(x) (x).begin(), (x).end()
#define TIME  (1.0 * clock() / CLOCKS_PER_SEC)
#define file(name)  if (fopen(name".inp", "r")) { freopen(name".inp", "r", stdin); freopen(name".out", "w", stdout); }
#define ii pair <int, long long>
#define fi first
#define se second
using namespace std;

const int MAXN = 2e5 + 5;

int N, a[MAXN];
long long K;

void add(long long &x, long long val) {
    x += val;
    x = min(x, K + 1);
}

ii bit[MAXN];
void upd(int x, ii val) {
    for (; x; x -= x&-x) {
        if (bit[x].fi < val.fi) bit[x] = val;
        else if (bit[x].fi == val.fi) add(bit[x].se, val.se);
    }
}

ii get(int x) {
    ii ans = {0, 1};
    for (; x <= N; x += x&-x) {
        if (ans.fi == bit[x].fi) add(ans.se, bit[x].se);
        else if (ans.fi < bit[x].fi) ans = bit[x];
    }
    return ans;
}

vector <ii> lis[MAXN];
long long dp[MAXN];

bool isAns[MAXN];

signed main(void) {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    cin >> N >> K;
    FOR(i, 1, N) cin >> a[i];

    int maxLen = 0;
    FOD(i, N, 1) {
        ii tmp = get(a[i]);
        maxLen = max(maxLen, ++tmp.fi);
        lis[tmp.fi].emplace_back(a[i], i);
        dp[i] = tmp.se;
        upd(a[i], tmp);
    }
    FOR(i, 1, N) isAns[i] = 1;
    int prv = 0;
    FOD(i, maxLen, 1) {
        sort(ALL(lis[i]), greater <ii>());
        for (auto x : lis[i]) {
            if (prv > x.se) continue;
            if (K > dp[x.se]) K -= dp[x.se];
            else {
                prv = x.se;
                isAns[x.fi] = 0;
                break;
            }
        }
    }
    cout << N - maxLen << '\n';
    FOR(i, 1, N) if (isAns[i]) cout << i << '\n';
    return 0;
}
